# Magic World Server 

### Install ZeroC Ice on Ubuntu 16.04
```
sudo apt-key adv --keyserver keyserver.ubuntu.com --recv B6391CB2CFBA643D
sudo apt-add-repository "deb http://zeroc.com/download/Ice/3.7/ubuntu16.04 stable main"
sudo apt-get update
```

Install Ice for C++, Java, Python, PHP, and all Ice services
```
sudo apt-get install zeroc-ice-all-runtime zeroc-ice-all-dev
```

Install Freeze for C++
```
sudo apt-get install libzeroc-freeze-dev zeroc-freeze-utils
```

### Generate headers
```
slice2cpp Printer.ice
```

### Compile & link
```
c++ -I. -DICE_CPP11_MAPPING -c MW.cpp MWServer.cpp MWMap.cpp MWSession.o -lGlacier2++11 -std=c++11 -lIce++11 -pthread
c++ -o server MW.o MWServer.o MWMap.o MWSessionI.o -std=c++11 -lIce++11 -lGlacier2++11 -pthread
```

### Rub the server
```
./server --Ice.Config=/home/r/src/mw_server/src/config.server
```

### Run the Glacier2 router
```
glacier2router --Ice.Config=/home/r/src/mw_server/src/config.glacier2
```
