#ifndef MW_MAP_SESSION_I_H
#define MW_MAP_SESSION_I_H

#include <Ice/Ice.h>
#include <MWSessionI.h>
#include <list>

using namespace std;
using namespace MW;

//
// MWMap helper singleton
//

class MWMap
{
public:

  static MWMap* instance();

  void enter(const shared_ptr<MWSessionPrx>&, const shared_ptr<MWCallbackPrx>&, const Ice::Current&);
  void leave(const shared_ptr<MWCallbackPrx>&, const Ice::Current&);
  void message(const string&) const;
  void deadRouter(const shared_ptr<Ice::Connection>&);
  void destroy();

private:

    mutex _mutex;
    list<shared_ptr<MWCallbackPrx>> _callbacks;

    //
    // Map of connection from Glacier2 to proxies of Chat Sessions in this server
    //
    map<shared_ptr<Ice::Connection>, list<shared_ptr<MWSessionPrx>>> _connectionMap;
};

#endif
