#ifndef MW_SESSION_I_H
#define MW_SESSION_I_H

#include <MW.h>
#include <Glacier2/Glacier2.h>
#include <mutex>

class MWSessionI : public MW::MWSession
{
public:

    MWSessionI(const std::string&);

    virtual void setCallback(std::shared_ptr<MW::MWCallbackPrx>, const Ice::Current&) override;
    virtual void sendPosition(std::string, const Ice::Current&) override; 
    virtual void destroy(const Ice::Current&) override;

private:

    std::mutex _mutex;
    const std::string _userId;
    std::shared_ptr<MW::MWCallbackPrx> _callback;
};

class MWSessionManagerI : public Glacier2::SessionManager
{
public:

    virtual std::shared_ptr<Glacier2::SessionPrx>
    create(std::string, std::shared_ptr<Glacier2::SessionControlPrx>, const Ice::Current&) override;

    void destroy();
};

#endif
